<?php
/**
 * Copyright ETS Software Technology Co., Ltd
 *
 * NOTICE OF LICENSE
 *
 * This file is not open source! Each license that you purchased is only available for 1 website only.
 * If you want to use this file on more websites (or projects), you need to purchase additional licenses.
 * You are not allowed to redistribute, resell, lease, license, sub-license or offer our resources to any third party.
 *
 * DISCLAIMER
 *
 * Do not edit or add to this file if you wish to upgrade PrestaShop to newer
 * versions in the future.
 *
 * @author ETS Software Technology Co., Ltd
 * @copyright  ETS Software Technology Co., Ltd
 * @license    Valid for 1 website (or project) for each purchase of license
 */

if (!defined('_PS_VERSION_')) { exit; }

/**
 * Class AdminShippingCostRuleController
 * @property \Ets_shippingcost $module
 */
class AdminShippingCostRuleController extends ModuleAdminController
{
    public $current_link;
    public $html ='';
    public $_errors = array();
    public function __construct()
    {
        $this->bootstrap = true;
        parent::__construct();
    }
    public function init()
    {
        parent::init(); // TODO: Change the autogenerated stub
        $this->current_link = $this->context->link->getAdminLink('AdminShippingCostRule');
    }
    public function initContent()
    {
        parent::initContent();
        Ets_shippingcost::registerPlugins();
        if(Tools::isSubmit('btnSubmitSettingsRule'))
            $this->submitSettingsRule();
        
        if(Tools::isSubmit('btnSubmitCombine'))
        {
            $this->submitCombine();
        }
        if(Tools::isSubmit('delPromote') && ($id_ets_sc_promote_rule = (int)Tools::getValue('id_ets_sc_promote_rule')))
        {
            $promote = new Ets_sc_promote_rule($id_ets_sc_promote_rule);
            if($promote->delete())
            {
                die(
                    json_encode(
                        array(
                            'success' => $this->l('Deleted successfully'),
                            'id_ets_sc_promote_rule' => $promote->id,
                        )
                    )
                );
            }
        }
        if(Tools::isSubmit('editpromoterule') && ($id_ets_sc_promote_rule = (int)Tools::getValue('id_ets_sc_promote_rule')))
        {
            $promote = new Ets_sc_promote_rule($id_ets_sc_promote_rule);
            if(Tools::isSubmit('ajax'))
            {
                die(
                    json_encode(
                        array(
                            'form_html' => $promote->renderForm(),
                        )
                    )
                );
            }
            else
                return $promote->renderForm();
        }
        if(Tools::isSubmit('save_promote_discount_rule'))
        {
            $this->submitSavePromoteRule();
        }
        if(Tools::isSubmit('del') && ($id_ets_sc_shipping_rule=(int)Tools::getValue('id_ets_sc_shipping_rule')) && ($rule = new Ets_sc_shipping_rule($id_ets_sc_shipping_rule)) && Validate::isLoadedObject($rule)) 
        {
            $rule->delete();
            $this->context->cookie->success_message = $this->l('Deleted successfully');
            Tools::redirect($this->current_link);
        }
        if(Tools::isSubmit('change_enabled'))
        {
            $change_enabled = (int)Tools::getValue('change_enabled');
            if($id_ets_sc_promote_rule = (int)Tools::getValue('id_ets_sc_promote_rule'))
            {
                $promote = new Ets_sc_promote_rule($id_ets_sc_promote_rule);
                $promote->enabled = $change_enabled;
                if($promote->update())
                {
                    $this->context->cookie->success_message = $this->l('Updated successfully');
                    Tools::redirectAdmin($this->current_link.'&editshipping_rule=1&id_ets_sc_shipping_rule='.(int)$promote->id_ets_sc_shipping_rule.'&current_tab=discount');
                }
            }
            elseif(($id_ets_sc_shipping_rule = (int)Tools::getValue('id_ets_sc_shipping_rule')))
            {
                $rule = new Ets_sc_shipping_rule($id_ets_sc_shipping_rule);
                $rule->active = $change_enabled;
                if($rule->update())
                {
                    $this->context->cookie->success_message = $this->l('Updated successfully');
                    Tools::redirectAdmin($this->current_link);
                }
            }
            
        }
        if(Tools::isSubmit('delCondition') && ($id_ets_sc_condition_rule = (int)Tools::getValue('id_ets_sc_condition_rule')))
        {
            $condition = new Ets_sc_condition_rule($id_ets_sc_condition_rule);
            if($condition->delete())
            {
                die(
                    json_encode(
                        array(
                            'success' => $this->l('Deleted successfully'),
                            'id_ets_sc_condition_rule' => $condition->id,
                        )
                    )
                );
            }
        }
        if(Tools::isSubmit('editconditionrule') && ($id_ets_sc_condition_rule = (int)Tools::getValue('id_ets_sc_condition_rule')))
        {
            $condition = new Ets_sc_condition_rule($id_ets_sc_condition_rule);
            if(Tools::isSubmit('ajax'))
            {
                die(
                    json_encode(
                        array(
                            'form_html' => $condition->renderForm(),
                        )
                    )
                );
            }
            else
                return $condition->renderForm();
        }
        if(Tools::isSubmit('save_action_rule'))
        {
            $this->saveActionRule();
        }
        if(Tools::isSubmit('save_shipping_rule'))
        {
            $this->submitSaveShippingRule();
        }
        if(Tools::isSubmit('save_condition_rule'))
        {
            $this->submitSaveConditionRule();
        }
        if(Tools::isSubmit('getCountries'))
        {
            $id_country = (int)Tools::getValue('id_country');
            $id_zone = (int)Tools::getValue('id_zone');
            die(
                json_encode(
                    array(
                        'list_state' =>Tools::isSubmit('getStates') ?  $this->displayListStates($id_country,$id_zone):false,
                        'list_countries' => $this->displayListCountries($id_zone,Tools::isSubmit('getStates')?true: false),
                    )
                )
            ); 
        }
        if(Tools::isSubmit('getStates'))
        {
            $id_country = (int)Tools::getValue('id_country');
            $id_zone = (int)Tools::getValue('id_zone');
            die(
                json_encode(
                    array(
                        'list_state' => $this->displayListStates($id_country,$id_zone)
                    )
                )
            ); 
        }
    }
    public function displayListCountries($id_zone,$default= false)
    {
        if($countries = Ets_sc_shipping_rule::getInstance()->getListCountries($id_zone))
        {
            $this->context->smarty->assign(
                array(
                    'countries' => $countries,
                    'default' => $default,
                )
            );
            return $this->module->display(_PS_MODULE_DIR_.$this->module->name.DIRECTORY_SEPARATOR.$this->module->name.'.php', 'countries.tpl');
        }
        return '';
    }
    public function displayListStates($id_country,$id_zone)
    {
        if($states = Ets_sc_shipping_rule::getInstance()->getListStates($id_country,$id_zone))
        {
	        $content = '';
	        foreach ($states as $state) {
		        $content .= $this->module->displayText($state['name'], 'option', '', '', '', '', '', '', '', $state['id_state']);
	        }
	        return $content;
        }
        return '';
    }
    public function renderList()
    {
        if(!$this->module->active)
            return $this->displayWarning($this->l('You must enable Shipping Cost Pro module to configure its features'));
        if($this->context->cookie->success_message)
        {
            $this->html .= $this->module->displayConfirmation($this->context->cookie->success_message);
            $this->context->cookie->success_message ='';
        }
        if($this->module->_errors)
            $this->html .= $this->module->displayError($this->module->_errors);
        if($this->context->cookie->error_message)
        {
            $this->html .= $this->module->displayError($this->context->cookie->error_message);
            $this->context->cookie->error_message ='';
        }
        $rule_tab = Tools::getValue('rule_tab','shipping_rule');
        if(!in_array($rule_tab,array('shipping_rule','shipping_report','settings')))
            $rule_tab = 'shipping_rule';
        $this->context->smarty->assign(
            array(
                'link' => $this->context->link,
                'rule_tab'=>  $rule_tab,
                'shipping_rule' => $rule_tab == 'shipping_rule' ? $this->renderShippingRule():'',
                'setting_form' =>  $rule_tab == 'settings' ? $this->renderSettings():'',
                'shipping_rule_report' =>  $rule_tab == 'shipping_report' ? $this->renderRuleReport():'',
            )
        );
        return $this->html.$this->module->display(_PS_MODULE_DIR_.$this->module->name.DIRECTORY_SEPARATOR.$this->module->name.'.php', 'admin.tpl');
    }
    public function renderShippingRule()
    {
        if(Tools::isSubmit('addNewShippingRule') || Tools::isSubmit('editshipping_rule'))
            return $this->module->renderFormShippingRule();
        $fields_list = array(
            'id_ets_sc_shipping_rule' => array(
                'title' => $this->l('ID'),
                'width' => 40,
                'type' => 'text',
                'sort' => true,
                'filter' => true,
            ),
            'name' => array(
                'title' => $this->l('Shipping rule'),
                'width' => 40,
                'type' => 'text',
                'sort' => true,
                'filter' => true,
            ),
            'type_action' => array(
                'title' => $this->l('Action'),
                'type' => 'select',
                'strip_tag' => false,
                'filter'=> true,
                'sort' => false,
                'filter_list' => array( 
                    'id_option' => 'active',
                    'value' => 'title',
                    'list' => array(
                        array(
                            'active' => 'increase',
                            'title' => $this->l('Increase default shipping cost')
                        ),
                        array(
                            'active' => 'decrease',
                            'title' => $this->l('Decrease default shipping cost')
                        ),
                        array(
                            'active' => 'replace',
                            'title' => $this->l('Replace default shipping cost by the cost from this rule')
                        ),
                        array(
                            'active' => 'free',
                            'title' => $this->l('Mark as "Free shipping"')
                        ),
                    )
                ),
            ),
            'list_carriers' => array(
                'title' => $this->l('Carriers'),
                'type' => 'text',
                'sort' => false,
                'filter' => false,
                'strip_tag' => false,
            ),
            'active' => array(
                'title' => $this->l('Active'),
                'type' => 'active',
                'sort' => true,
                'filter' => true,
                'filter_list' => array(
                    'id_option' => 'active',
                    'value' => 'title',
                    'list' => array(
                        0 => array(
                            'active' => 0,
                            'title' => $this->l('Disabled')
                        ),
                        1 => array(
                            'active' => 1,
                            'title' => $this->l('Enabled')
                        ),
                    )
                )
            ),
            'priority' => array(
                'title' => $this->l('Priority'),
                'type' => 'int',
                'sort' => true,
                'filter' => true,
            )
        );
        $filter = '';
        $show_resset = false;
        if(($id_ets_sc_shipping_rule = Tools::getValue('id_ets_sc_shipping_rule'))!='' && Validate::isCleanHtml($id_ets_sc_shipping_rule))
        {
            $filter .= ' AND sr.id_ets_sc_shipping_rule='.(int)$id_ets_sc_shipping_rule;
            $show_resset = true;
        }
        if(($name=Tools::getValue('name'))!='' && Validate::isCleanHtml($name))
        {
            $filter .= ' AND srl.name LIKE "%'.pSQL($name).'%"';
            $show_resset = true;
        }
        if(($active=Tools::getValue('active'))!='' && Validate::isCleanHtml($active))
        {
            $filter .= ' AND sr.active = "'.(int)$active.'"';
            $show_resset = true;
        }
       
        if(($priority_min = Tools::getValue('priority_min'))!='' && Validate::isCleanHtml($priority_min))
        {
            $filter .= ' AND sr.priority >= "'.(int)$priority_min.'"';
            $show_resset = true;
        }
        if(($priority_max = Tools::getValue('priority_max'))!='' && Validate::isCleanHtml($priority_max))
        {
            $filter .= ' AND sr.priority <= "'.(int)$priority_max.'"';
            $show_resset = true;
        }
        if(($type_action = Tools::getValue('type_action'))!='' && Validate::isCleanHtml($type_action))
        {
            $filter .= ' AND ar.type_action = "'.pSQL($type_action).'"';
            $show_resset = true;
        }
        $sort = "";
        $sort_type=Tools::getValue('sort_type','asc');
        $sort_value = Tools::getValue('sort','id_ets_sc_shipping_rule');
        if($sort_value)
        {
            switch ($sort_value) {
                case 'id_ets_sc_shipping_rule':
                    $sort .=' sr.id_ets_sc_shipping_rule';
                    break;
                case 'name':
                    $sort .=' srl.name';
                    break;
                case 'active':
                    $sort .=' sr.active';
                    break;
                case 'priority':
                    $sort .=' sr.priority';
                    break;
            }
            if($sort && $sort_type && in_array($sort_type,array('asc','desc')))
                $sort .= ' '.$sort_type;
        }
        //Paggination
        $page = (int)Tools::getValue('page');
        if($page<=0)
            $page = 1;
        $totalRecords = Ets_sc_shipping_rule::getShippingRules($filter,$sort,0,0,true);
        $paggination = new Ets_sc_paggination_class();            
        $paggination->total = $totalRecords;
        $paggination->url = $this->current_link.'&page=_page_'.$this->module->getFilterParams($fields_list,'rule');
        $paggination->limit =  (int)Tools::getValue('paginator_shipping_rule_select_limit',20);
        $paggination->name ='shipping_rule';
        $totalPages = ceil($totalRecords / $paggination->limit);
        if($page > $totalPages)
            $page = $totalPages;
        $paggination->page = $page;
        $start = $paggination->limit * ($page - 1);
        if($start < 0)
            $start = 0;
        $shipping_rules= Ets_sc_shipping_rule::getShippingRules($filter,$sort,$start,$paggination->limit,false);
        if($shipping_rules)
        {
            foreach($shipping_rules as &$shipping_rule)
            {
                if($shipping_rule['type_action']=='increase')
                    $shipping_rule['type_action'] = $this->l('Increase default shipping cost');
                elseif($shipping_rule['type_action']=='decrease')
                    $shipping_rule['type_action'] = $this->l('Decrease default shipping cost');
                elseif($shipping_rule['type_action']=='replace')
                    $shipping_rule['type_action'] = $this->l('Replace default shipping cost by the cost from this rule');
                elseif($shipping_rule['type_action']=='free')
                    $shipping_rule['type_action'] = $this->l('Mark as "Free shipping"');
                else
                    $shipping_rule['type_action'] = $this->module->displayText($this->l('No action'),'span','rule_no_action',null,null,null,null,null, null,null,null,null,null,array(array('name'=>'title','value'=>$this->l('The rule does not work because no action is added'))));
                if($shipping_rule['id_carriers'])
                {
                    if($shipping_rule['id_carriers']=='all')
                        $shipping_rule['list_carriers'] = $this->l('All carriers');
                    else
                    {
                    	$list_carriers = Ets_sc_shipping_rule::getCarriers(' AND c.id_reference IN('.implode(',',array_map('intval',explode(',',$shipping_rule['id_carriers']))).')');

	                    if ($list_carriers && count($list_carriers)) {
		                    $content = '';
		                    foreach ($list_carriers as $carrier) {
			                    $content .= $this->module->displayText($carrier['name'], 'li');
		                    }
		                    $shipping_rule['list_carriers'] = $this->module->displayText($content, 'ul', 'pl_10');
	                    } else {
		                    $shipping_rule['list_carriers'] = '--';
	                    }
                    }
                }
            }
        }
        $paggination->text =  $this->l('Showing {start} to {end} of {total} ({pages} Pages)');
        $paggination->style_links = $this->l('links');
        $paggination->style_results = $this->l('results');
        $listData = array(
            'name' => 'shipping_rule',
            'actions' => array('view','delete'), //'duplicate','view_report',
            'icon' => 'icon-shipping-rule',
            'currentIndex' => $this->current_link.($paggination->limit!=20 ? '&paginator_shipping_rule_select_limit='.$paggination->limit:''),
            'postIndex' => $this->current_link,
            'identifier' => 'id_ets_sc_shipping_rule',
            'show_toolbar' => true,
            'show_action' => true,
            'show_add_new' => true,
            'link_new' => $this->current_link.'&addNewShippingRule=1',
            'add_new_text' => $this->l('Add new shipping rule'),
            'title' => $this->l('Shipping rules'),
            'fields_list' => $fields_list,
            'field_values' => $shipping_rules,
            'paggination' => $paggination->render(),
            'filter_params' => $this->module->getFilterParams($fields_list,'rule'),
            'show_reset' =>$show_resset,
            'totalRecords' => $totalRecords,
            'sort'=> $sort_value,
            'sort_type' => $sort_type,
        );            
        return  $this->module->renderList($listData);
    }
    public function renderSettings()
    {
        $fields_form = array(
            'form' => array(
                'legend' => array(
                    'title' => $this->l('Settings'),
                    'icon' => ''
                ),
                'input' => Ets_sc_defines::getInstance()->getConfigInputs(),
                'submit' => array(
                    'title' => $this->l('Save'),
                )
            ),
        );
        $helper = new HelperForm();
        $helper->show_toolbar = false;
        $helper->id = $this->module->id;
        $helper->module = $this->module;
        $helper->identifier = $this->identifier;
        $helper->submit_action = 'btnSubmitSettingsRule';
        $helper->currentIndex = $this->context->link->getAdminLink('AdminShippingCostRule', false);
        $helper->token = Tools::getAdminTokenLite('AdminShippingCostRule');
        $language = new Language((int)Configuration::get('PS_LANG_DEFAULT'));
        $helper->default_form_language = $language->id;
      
        $helper->tpl_vars = array(
            'base_url' => $this->context->shop->getBaseURL(),
			'language' => array(
				'id_lang' => $language->id,
				'iso_code' => $language->iso_code
			),
            'PS_ALLOW_ACCENTED_CHARS_URL', (int)Configuration::get('PS_ALLOW_ACCENTED_CHARS_URL'),
            'fields_value' => $this->getConfigFieldsValues(),
            'languages' => $this->context->controller->getLanguages(),
			'id_language' => $this->context->language->id,
            'link' => $this->context->link,
        );
        $this->fields_form = array();
        return $helper->generateForm(array($fields_form));
    }
    public function getConfigFieldsValues()
    {
        $languages = Language::getLanguages(false);
        $fields = array();
        $inputs = Ets_sc_defines::getInstance()->getConfigInputs();
        if($inputs)
        {
            foreach($inputs as $input)
            {
                if($input['type']=='html')
                    continue;
                if(!isset($input['lang']))
                {
                    if($input['type']=='checkbox')
                    {
                         $fields[$input['name']] = Tools::getValue($input['name'],Configuration::get($input['name']) ? explode(',',Configuration::get($input['name'])):array());
                    }
                    else
                        $fields[$input['name']] = Tools::getValue($input['name'],Configuration::get($input['name']));
                }
                else
                {
                    foreach($languages as $language)
                    {
                        $fields[$input['name']][$language['id_lang']] = Tools::getValue($input['name'].'_'.$language['id_lang'],Configuration::get($input['name'],$language['id_lang']));
                    }
                }
            }
        }
        return $fields;
    }
    public function settingsValidation()
    {
        $languages = Language::getLanguages(false);
        $inputs = Ets_sc_defines::getInstance()->getConfigInputs();
        $id_lang_default = Configuration::get('PS_LANG_DEFAULT');
        foreach($inputs as $input)
        {
            if($input['type']=='html')
                continue;
            if(isset($input['lang']) && $input['lang'])
            {
                if(isset($input['required']) && $input['required'])
                {
                    $val_default = Tools::getValue($input['name'].'_'.$id_lang_default);
                    if(!$val_default)
                    {
                        $this->_errors[] = sprintf($this->l('%s is required'),$input['label']);
                    }
                    elseif($val_default && isset($input['validate']) && ($validate = $input['validate']) && method_exists('Validate',$validate) && !Validate::{$validate}($val_default))
                        $this->_errors[] = sprintf($this->l('%s is not valid'),$input['label']);
                    elseif($val_default && !Validate::isCleanHtml($val_default))
                        $this->_errors[] = sprintf($this->l('%s is not valid'),$input['label']);
                    else
                    {
                        foreach($languages as $language)
                        {
                            if(($value = Tools::getValue($input['name'].'_'.$language['id_lang'])) && isset($input['validate']) && ($validate = $input['validate']) && method_exists('Validate',$validate)  && !Validate::{$validate}($value))
                                $this->_errors[] = sprintf($this->l('%s is not valid in %s'),$input['label'],$language['iso_code']);
                            elseif($value && !Validate::isCleanHtml($value))
                                $this->_errors[] = sprintf($this->l('%s is not valid in %s'),$input['label'],$language['iso_code']);
                        }
                    }
                }
                else
                {
                    foreach($languages as $language)
                    {
                        if(($value = Tools::getValue($input['name'].'_'.$language['id_lang'])) && isset($input['validate']) && ($validate = $input['validate']) && method_exists('Validate',$validate)  && !Validate::{$validate}($value))
                            $this->_errors[] = sprintf($this->l('%s is not valid in %s'),$input['label'],$language['iso_code']);
                        elseif($value && !Validate::isCleanHtml($value))
                            $this->_errors[] = sprintf($this->l('%s is not valid in %s'),$input['label'],$language['iso_code']);
                    }
                }
            }
            else
            {
                $val = Tools::getValue($input['name']);
                if($val===''&& isset($input['required']))
                {
                    $this->_errors[] = sprintf($this->l('%s is required'),$input['label']);
                }
                if($val!=='' && isset($input['validate']) && ($validate = $input['validate']) && method_exists('Validate',$validate) && !Validate::{$validate}($val))
                {
                    $this->_errors[] = sprintf($this->l('%s is not valid'),$input['label']);
                }
                elseif(is_array($val))
                {
                    if($val && !Ets_shippingcost::validateArray($val))
                        $this->_errors[] = sprintf($this->l('%s is not valid'),$input['label']);
                }    
                elseif($val!==''&& !Validate::isCleanHtml($val))
                    $this->_errors[] = sprintf($this->l('%s is not valid'),$input['label']);
            }
        }
    }
    public function submitSettingsRule()
    {
        $this->settingsValidation();
        if (!count($this->_errors)) {
        	$this->module->_clearSmartyCacheWhenUpdateConfig();
            $inputs = Ets_sc_defines::getInstance()->getConfigInputs();
            $languages = Language::getLanguages(false);
            $id_lang_default = Configuration::get('PS_LANG_DEFAULT');
            foreach($inputs as $input)
            {
                if($input['type']!='html')
                {
                    if(isset($input['lang']) && $input['lang'])
                    {
                        $values = array();
                        foreach($languages as $language)
                        {
                            $value_default = Tools::getValue($input['name'].'_'.$id_lang_default);
                            $value = Tools::getValue($input['name'].'_'.$language['id_lang']);
                            $values[$language['id_lang']] = ($value && Validate::isCleanHtml($value)) || !isset($input['required']) ? $value : (Validate::isCleanHtml($value_default) ? $value_default :'');
                        }
                        Configuration::updateValue($input['name'],$values);
                    }
                    else
                    {
                        $val = Tools::getValue($input['name']);
                        if($input['type']=='checkbox')
                        {
                            Configuration::updateValue($input['name'],$val ? implode(',',$val):'');
                        }
                        else
                        {
                            if(Validate::isCleanHtml($val))
                                Configuration::updateValue($input['name'],$val);
                        }
                        
                    }
                }
                
            }
            die(
                json_encode(
                    array(
                        'success' => $this->l('Settings updated'),
                    )
                )
            );
        } else {
            die(
                json_encode(
                    array(
                        'errors' => $this->module->displayError($this->_errors),
                    )
                )
            );
        }
    }
    public function renderRuleReport()
    {
        if(Tools::isSubmit('viewRuleReport'))
            return $this->displayViewRuleReport();
        $fields_list = array(
            'id_ets_sc_shipping_rule' => array(
                'title' => $this->l('ID'),
                'width' => 40,
                'type' => 'text',
                'sort' => true,
                'filter' => true,
            ),
            'name' => array(
                'title' => $this->l('Rule name'),
                'width' => 40,
                'type' => 'text',
                'strip_tag'=> false,
                'sort' => true,
                'filter' => true,
            ),
            'active' => array(
                'title' => $this->l('Active'),
                'type' => 'active',
                'sort' => true,
                'filter' => true,
                'filter_list' => array(
                    'id_option' => 'active',
                    'value' => 'title',
                    'list' => array(
                        0 => array(
                            'active' => 0,
                            'title' => $this->l('Disabled')
                        ),
                        1 => array(
                            'active' => 1,
                            'title' => $this->l('Enabled')
                        ),
                    )
                )
            ),
            'total_order' => array(
                'title' => $this->l('Applied'),
                'width' => 40,
                'type' => 'int',
                'sort' => true,
                'filter' => false,
            ),
            'new_customer' => array(
                'title' => $this->l('New customer'),
                'width' => 40,
                'type' => 'int',
                'sort' => true,
                'filter' => false,
            ),
            'total_amount' => array(
                'title' => $this->l('Total order amount'),
                'width' => 40,
                'type' => 'int',
                'sort' => true,
                'filter' => false,
            ),
        );
        $filter = '';
        $show_resset = false;
        if(($id_ets_sc_shipping_rule = Tools::getValue('id_ets_sc_shipping_rule'))!='' && Validate::isCleanHtml($id_ets_sc_shipping_rule))
        {
            $filter .= ' AND r.id_ets_sc_shipping_rule='.(int)$id_ets_sc_shipping_rule;
            $show_resset = true;
        }
        if(($name=Tools::getValue('name'))!='' && Validate::isCleanHtml($name))
        {
            $filter .= ' AND rl.name LIKE "%'.pSQL($name).'%"';
            $show_resset = true;
        }
        if(($active=Tools::getValue('active'))!='' && Validate::isCleanHtml($active))
        {
            $filter .= ' AND r.active = "'.(int)$active.'"';
            $show_resset = true;
        }
        $sort = "";
        $sort_type=Tools::getValue('sort_type','desc');
        $sort_value = Tools::getValue('sort','total_amount');
        if($sort_value)
        {
            switch ($sort_value) {
                case 'id_ets_sc_shipping_rule':
                    $sort .=' r.id_ets_sc_shipping_rule';
                    break;
                case 'name':
                    $sort .=' rl.name';
                    break;
                case 'active':
                    $sort .=' r.active';
                    break;
                case 'total_order':
                    $sort .=' total_order';
                    break;
                case 'total_amount':
                    $sort .=' total_amount';
                    break;
                case 'new_customer':
                    $sort .=' new_customer';
                    break;
            }
            if($sort && $sort_type && in_array($sort_type,array('asc','desc')))
                $sort .= ' '.$sort_type;
        }
        //Paggination
        $page = (int)Tools::getValue('page');
        if($page<=0)
            $page = 1;
        $totalRecords = (int)Ets_sc_shipping_rule::getRuleReports($filter,$sort,0,0,true);
        $paggination = new Ets_sc_paggination_class();            
        $paggination->total = $totalRecords;
        $paggination->url = $this->context->link->getAdminLink('AdminShippingCostRule').'&page=_page_&rule_tab=shipping_report'.$this->module->getFilterParams($fields_list,'rule_report');
        $paggination->limit =  (int)Tools::getValue('paginator_rule_report_select_limit',20);
        $paggination->name ='rule_report';
        $totalPages = ceil($totalRecords / $paggination->limit);
        if($page > $totalPages)
            $page = $totalPages;
        $paggination->page = $page;
        $start = $paggination->limit * ($page - 1);
        if($start < 0)
            $start = 0;
        $rules= Ets_sc_shipping_rule::getRuleReports($filter,$sort,$start,$paggination->limit,false);
        if($rules)
        {
            foreach($rules as &$rule)
            {
                $rule['total_amount'] = Tools::displayPrice($rule['total_amount']);
                $rule['action_edit'] = false;
                $rule['child_view_url'] = $this->context->link->getAdminLink('AdminShippingCostRule').'&rule_tab=shipping_report&viewRuleReport='.(int)$rule['id_ets_sc_shipping_rule'];
                $rule['name'] = $this->module->displayText($rule['name'],'a',null,null,$this->context->link->getAdminLink('AdminShippingCostRule').'&editshipping_rule=1&id_ets_sc_shipping_rule='.(int)$rule['id_ets_sc_shipping_rule']);
                if(!$rule['new_customer'])
                    $rule['new_customer']='--';
                if(!$rule['total_order'])
                    $rule['total_order']='--';
            }
        }
        $paggination->text =  $this->l('Showing {start} to {end} of {total} ({pages} Pages)');
        $paggination->style_links = $this->l('links');
        $paggination->style_results = $this->l('results');
        $listData = array(
            'name' => 'rule_report',
            'actions' => array('view'),
            'icon' => 'icon-rule',
            'currentIndex' => $this->current_link.'&rule_tab=shipping_report'.($paggination->limit!=20 ? '&paginator_rule_report_select_limit='.$paggination->limit:''),
            'postIndex' => $this->current_link.'&rule_tab=shipping_report',
            'identifier' => 'id_ets_sc_shipping_rule',
            'show_toolbar' => true,
            'show_action' => true,
            'show_add_new' => false,
            'title' => $this->l('Statistics'),
            'fields_list' => $fields_list,
            'field_values' => $rules,
            'paggination' => $paggination->render(),
            'filter_params' => $this->module->getFilterParams($fields_list,'rule'),
            'show_reset' =>$show_resset,
            'totalRecords' => $totalRecords,
            'sort'=> $sort_value,
            'sort_type' => $sort_type,
        );            
        return  $this->module->renderList($listData);
    }
    public function displayViewRuleReport()
    {
        if($id_rule = (int)Tools::getValue('viewRuleReport'))
        {
            $rule = new Ets_sc_shipping_rule($id_rule,$this->context->language->id);
            $this->context->smarty->assign(
                array(
                    'rule' => $rule,
                    'applied_orders' => $rule->getOrderApplied(),
                    'link'=> $this->context->link,
                )
            );
            return $this->context->smarty->fetch(_PS_MODULE_DIR_.$this->module->name.'/views/templates/hook/rule_report.tpl');
        }
        
    }
    public function submitSaveShippingRule()
    {
        $id_ets_sc_shipping_rule = (int)Tools::getValue('id_ets_sc_shipping_rule');
        if($id_ets_sc_shipping_rule)
            $shippingrule = new Ets_sc_shipping_rule($id_ets_sc_shipping_rule);
        else
            $shippingrule = new Ets_sc_shipping_rule($id_ets_sc_shipping_rule );
        $save = $shippingrule->saveData();
        if(isset($save['errors']) && $save['errors'])
            $this->html .= $this->module->displayError($save['errors']);
        elseif(isset($save['success']) && $save['success'])
        {
            $this->context->cookie->success_message = $this->l('Save successfully');
            if(Tools::isSubmit('btnSubmitShippingRuleStay'))
                Tools::redirectAdmin($this->current_link.'&editshipping_rule=1&id_ets_sc_shipping_rule='.$shippingrule->id.'&current_tab=information');
            else
                Tools::redirectAdmin($this->current_link.'&editshipping_rule=1&id_ets_sc_shipping_rule='.$shippingrule->id.'&current_tab=condition');
        }
    }
    public function submitSaveConditionRule()
    {
        $id_ets_sc_condition_rule = (int)Tools::getValue('id_ets_sc_condition_rule');
        if($id_ets_sc_condition_rule)
            $condition = new Ets_sc_condition_rule($id_ets_sc_condition_rule);
        else
            $condition = new Ets_sc_condition_rule();
        $save = $condition->saveData();
        if(isset($save['errors']) && $save['errors'])
        {
            die(
                json_encode(
                    array(
                        'errors' => $this->module->displayError($save['errors']),
                    )
                )
            );
        }
        elseif(isset($save['success']) && $save['success'])
        {
            switch($condition->parent_codition)
            {
                case 'specific_customer':
                    $parent_codition = $this->l('Customer - Specific customer');
                    $detail_condition = Ets_sc_condition_rule::displayListCustomer($condition);
                    break;
                case 'customer_group':
                    $parent_codition = $this->l('Customer - Customer group');
                    $detail_condition = Ets_sc_condition_rule::displayListGroup($condition);
                    break;
                case 'customer_membership':
                    $parent_codition = $this->l('Customer - Customer registration time');
                    $detail_condition = Ets_sc_condition_rule::displayCustomerMembership($condition);
                    break;
                case 'cart_amount':
                    $parent_codition = $this->l('Shopping cart - Cart amount');
                    $detail_condition = Ets_sc_condition_rule::displayCartAmount($condition);
                    break;
                case 'product_in_cart':
                    $parent_codition = $this->l('Shopping cart - Products in cart');
                    $detail_condition = Ets_sc_condition_rule::displayProductInCart($condition);
                    break;
                case 'specific_occasion':
                    $parent_codition = $this->l('Specific occasion');
                    $detail_condition = Ets_sc_condition_rule::displaySpecificOccasions($condition);
                    break;
                case 'delivery_zone':
                    $parent_codition = $this->l('Delivery location - Zone');
                    $detail_condition = Ets_sc_condition_rule::displayDeliveryZone($condition);
                    break;
                case 'delivery_country':
                    $parent_codition = $this->l('Delivery location - Country');
                    $detail_condition =  Ets_sc_condition_rule::displayDeliveryCountry($condition);
                    break;
                case 'delivery_zipcode':
                    $parent_codition = $this->l('Delivery location - ZIP code/Postal code');
                    $detail_condition =  Ets_sc_condition_rule::displayDeliveryZipcode($condition);
                    break;
                case 'delivery_state':
                    $parent_codition = $this->l('Shopping cart - State');
                    $detail_condition =  Ets_sc_condition_rule::displayDeliveryState($condition);
                    break;
                default :
                    $parent_codition = '';
                    $detail_condition ='';
                    
            }
            $this->context->smarty->assign(
                array(
                    'id_ets_sc_condition_rule' => $condition->id,
                    'detail_condition' => $detail_condition,
                    'parent_codition' => $parent_codition,
                    'link' => $this->context->link,
                )
            );
            die(
                json_encode(
                    array(
                        'success' => $this->l('Save condition successfully'),
                        'id_ets_sc_condition_rule' => $condition->id,
                        'row_condtion' => $this->module->display(_PS_MODULE_DIR_.$this->module->name.DIRECTORY_SEPARATOR.$this->module->name.'.php', 'condition/row.tpl'),
                    )
                )
            );
        }
    }
    public function saveActionRule()
    {
        if(($id_ets_sc_shipping_rule = (int)Tools::getValue('id_ets_sc_shipping_rule')) && ($rule = new Ets_sc_shipping_rule($id_ets_sc_shipping_rule)) && Validate::isLoadedObject($rule) )
        {
            $action = Ets_sc_action_rule::getActionByIdRule($id_ets_sc_shipping_rule);
            $save = $action->saveData();
            if(isset($save['errors']) && $save['errors'])
                $this->html .= $this->module->displayError($save['errors']);
            elseif(isset($save['success']) && $save['success'])
            {
                $this->context->cookie->success_message = $this->l('Save successfully');
                if(Tools::isSubmit('btnSubmitActionRuleStay'))
                    Tools::redirect($this->current_link.'&editshipping_rule=1&id_ets_sc_shipping_rule='.$rule->id.'&current_tab=action'); //discount
                else
                    Tools::redirect($this->current_link.'&editshipping_rule=1&id_ets_sc_shipping_rule='.$rule->id.'&current_tab=discount'); //discount
            }
        }
        else
            $this->html .= $this->module->displayError($this->l('Rule is required'));
    }
    public function submitSavePromoteRule()
    {
        $id_ets_sc_promote_rule = (int)Tools::getValue('id_ets_sc_promote_rule');
        if($id_ets_sc_promote_rule)
            $promote = new Ets_sc_promote_rule($id_ets_sc_promote_rule);
        else
            $promote = new Ets_sc_promote_rule();
        $save = $promote->saveData();
        if(isset($save['errors']) && $save['errors'])
        {
            die(
                json_encode(
                    array(
                        'errors' => $this->module->displayError($save['errors']),
                    )
                )
            );
        }
        elseif(isset($save['success']) && $save['success'])
        {
            switch($promote->way_to_promote)
            {
                case 'display_notification':
                    $way_to_promote = $this->l('Display notification message');
                    $detail =  $this->l('Notification: ').$promote->notification[$this->context->language->id];
                    $position_to_display = Ets_sc_promote_rule::displayPoisition($promote);
                    break;
                case 'display_banner':
                    $way_to_promote = $this->l('Display banner');
                    $detail =  Ets_sc_promote_rule::displayDetailBanner($promote);
                    $position_to_display = Ets_sc_promote_rule::displayPoisition($promote);
                    break;
                case 'display_popup':
                    $way_to_promote = $this->l('Display popup');
                    $detail =  Ets_sc_promote_rule::displayDetailPopup($promote);
                    $position_to_display = '--';
                    break;
                case 'display_highlight_bar':
                    $way_to_promote = $this->l('Display highlight bar');
                    $detail =  $this->l('Content: ').$promote->content_bar[$this->context->language->id];
                    $position_to_display = '--';
                    break;
            }
            $this->context->smarty->assign(
                array(
                    'id_ets_sc_promote_rule' => $promote->id,
                    'way_to_promote' => isset($way_to_promote) ? $way_to_promote :'',
                    'enabled' => $promote->enabled,
                    'id_ets_sc_shipping_rule' => $promote->id_ets_sc_shipping_rule,
                    'detail_promote' => isset($detail) ? $detail :'',
                    'position_to_display' => isset($position_to_display) ? $position_to_display :'',
                    'link' => $this->context->link,
                )
            );
            die(
                json_encode(
                    array(
                        'success' => $this->l('Saved promote way successfully'),
                        'id_ets_sc_promote_rule' => $promote->id,
                        'row_promote' => $this->context->smarty->fetch(_PS_MODULE_DIR_.$this->module->name.'/views/templates/hook/promote/row.tpl'),
                    )
                )
            );
        }
    }
    public function submitCombine(){
        $id_ets_sc_shipping_rule = (int)Tools::getValue('id_ets_sc_shipping_rule');
        $errors = array();
        if($id_ets_sc_shipping_rule && ($shippingRule = new Ets_sc_shipping_rule($id_ets_sc_shipping_rule)) && Validate::isLoadedObject($shippingRule))
        {
            $type_combine_condition = Tools::getValue('type_combine_condition','and');
            if(!in_array($type_combine_condition,array('and','or')))
            {
                $errors[] = $this->l('Combine shipping rule conditions is not valid');
            }
            else
            {
                $shippingRule->type_combine_condition = $type_combine_condition;
                if($shippingRule->update())
                {
                    die(
                        json_encode(
                            array(
                                'success' => $this->l('Updated successfully'),
                            )
                        )
                    );
                }
                else
                    $errors[] = $this->l('Update failed');
            }
        }
        if($errors)
        {
            die(
                json_encode(
                    array(
                        'errors' => $this->module->displayError($errors),
                    )
                )
            );
        }
    }

}